// -------------------------------------------------------------
//  ޥץ TCP/IPץ
//   -- 饤 --
//    (C)Copyright 2004, Yashiro Takeshi
//     This program is distributed under the MIT License.
// -------------------------------------------------------------

//#define DEBUG  // ǥХå⡼

#include <stdarg.h>
#include <basic.h>
#include <bstdio.h>
#include <bstring.h>
#include <tstring.h>
#include <vector>
#include "ystring.h"
#include "yexception.h"
#include "ytcpsocket.h"
#include "errorpanel.h"

using namespace YLibDraft;

#include "common.h"

int ppid = -1;

// ƥץ¸ߤĥ뤿ΥХå饦ɥ
void ppid_monitor_task(W arg)
{
  YTCPSocket *sock = (YTCPSocket*)arg;

  for (;;){
    if (prc_sts(ppid, NULL, NULL) == ER_NOPRC){
      break;
    }
    slp_tsk(500);
  }

  sock->close();
  ext_prc(0);
}

// ᥤ
extern "C" W MAIN(MESSAGE *msg)
{
  P_STATE psts;
  char* hostname = 0;
  int port = 0;
  int retval = ReturnState::TCP_OK;
  
  try {
    // å(ץ)ʬ
    TC* argv0 = (TC*)&(msg->msg_body);
    TC* argv1 = argv0;
    while (*argv1 == L'') argv1++;
    while (*argv1 != TNULL && *argv1 != L'') argv1++;
    while (*argv1 == L'') argv1++;
    TC* argv2 = argv1;
    for ( ; *argv2 != TNULL; argv2++){
      if (*argv2 == L''){
        *argv2 = TNULL;
        argv2++;
        break;
      }
    }
    if (argv2 == argv1 || *argv2 == TNULL){
      throw ReturnState::TCP_ARGNUM_STRANGE;
    }

    // ۥ̾ TC[] -> char[]
    int tcslen = tc_strlen(argv1);
    hostname = new char[tcslen*2 + 1];
    sprintf(hostname, "%S", argv1);
    if (hostname == 0 || hostname[0] == '\0'){
      throw ReturnState::TCP_HOST_STRANGE;
    }
    debug_printf("hostname: %s\n", hostname);

    // ݡֹ
    port = tcs2uint(argv2);
    debug_printf("port: %d\n", port);
    
    YTCPSocket sock;

    // Хå饦ɥ֤εư
    P_STATE psts;
    prc_sts(0, &psts, NULL);
    ppid = psts.parpid;

    cre_tsk(ppid_monitor_task, psts.priority, (W)&sock);

    // Фؤ³
    try {
      sock.connect(hostname, port);
    }
    catch (YException *e){
      delete e;
      throw ReturnState::TCP_CONNECTION_FAILED;
    }
    sendIntegerMessage(ReturnState::TCP_OK);

    // å̿Υ롼
    MScriptMsg *msg = 0;

    for (bool cont = true; cont; ){
      if ((msg = receiveMessage()) == 0){
        debug_printf("msg_loop : TCP_PROGMSG_RCV_FAILED\n");
        throw ReturnState::TCP_PROCMSG_RCV_FAILED;
      }

      if (msg->msg_size <= 6 || ((TC*)(msg->msg_body))[0] == TNULL){
        if (msg != 0){
          delete [] reinterpret_cast<UB*>(msg);
          msg = 0;
        }
        throw ReturnState::TCP_COMMAND_UNDEFINED;
      }

      try {
        switch (((TC*)(msg->msg_body))[0]){
        case L'':
        case L'':
          // "read, <size>" / <err> / <char[]:buf>
          sendSocketInput(sock, receiveIntegerMessage());
          break;
        case L'':
        case L'':
          // "write" / <err> / <char[]:buf>
          receiveSocketOutput(sock);
          break;
        case L'':
        case L'':
          // "close"
          cont = false;
          break;
        case L'':
        case L'':
          // "nbytes" / <err> / <int:size>
          sendSocketBufferSize(sock);
          break;
        default:
          if (msg != 0){
            delete [] reinterpret_cast<UB*>(msg);
          }
          throw ReturnState::TCP_COMMAND_UNDEFINED;
        }
      
        if (msg != 0){
          delete [] reinterpret_cast<UB*>(msg);
        }
      }
      catch (int val){
        if (val == ReturnState::TCP_CONNECTION_ABORTED){
          throw;
        }
        // Τۤξ̵뤷ƥ롼פ³
        sendIntegerMessage(val);
      }
    }

    // Ф
    sock.close();
  }
  catch (int v){
    debug_printf("error: (%d)", v);
    retval = v;
  }
  catch (YException *e){
    const TC* s = e->getMessage();
    debug_printf("error: %S (%d)\n", s, ReturnState::TCP_UNDEFINED);
    delete e;
    retval = ReturnState::TCP_UNDEFINED;
  }

  // λβ
  delete hostname;

exit_prog:
  // ǡretval
  sendIntegerMessage(retval);
  return retval;
}

