#ifndef DEFINE_H_COMMON
#define DEFINE_H_COMMON

// åפλ
#define TCPIP_MM_TYPE MM_TYPE7
#define TCPIP_MS_TYPE MS_TYPE7

// 顼ֹ ( enum Τ֤ۤ˾ޤ)
struct ReturnState {
  // 
  static const int TCP_OK = 0; // OK
  // ¹Ի TCP/IP ̿顼
  static const int TCP_CONNECTION_ABORTED = -1; // ³Ǥ줿
  static const int TCP_OPERATION_TIMEDOUT = -2; // ॢ
  static const int TCP_CONNECTION_FAILED = -3; // ³˼
  static const int TCP_IOCTL_FAILED = -4; // ּ˼
  static const int TCP_BINDLISTEN_FAILED = -5; // bind, listen˼
  static const int TCP_ACCEPT_FAILED = -5; // accept˼
  // ¹Ի ץ̿顼
  static const int TCP_PROCMSG_RCV_FAILED = -101; // å˼
  static const int TCP_PROCMSG_SEND_FAILED = -102; // å˼ 
  // ץΥХˤ륨顼
  static const int TCP_ARGNUM_STRANGE = -501; // ο㤦
  static const int TCP_PORT_STRANGE = -502; // ݡֹλ꤬
  static const int TCP_HOST_STRANGE = -503; // ۥȤλ꤬
  static const int TCP_COMMAND_UNDEFINED = -504; // ¸ߤʤ̿᤬줿
  static const int TCP_ARGUMENT_WRONG = -505; // 
  static const int TCP_SOCKETFD_WRONG = -506; // åID
  // ̤
  static const int TCP_UNDEFINED = -900; // ̤Υ顼
};

// ޥץȤȤΥץ̿Ѥι¤
struct MScriptMsg {
  W msg_type;
  W msg_size;
  W ext_size; // ޥץȤξ;ʬ¸
  UB msg_body[0]; // size = msg_size - sizeof(ext_size)
};

// ǥХåѤ printf 
#ifdef DEBUG
#define debug_printf printf
#else
inline void debug_printf(...) {};
#endif

// åμ (Ѹ˸ƤӽФ¦ delete [] (UB*) 뤳ȡ)
MScriptMsg* receiveMessage()
{
  MESSAGE dummy;
  MScriptMsg *msg = 0;
  W mpid, msize, rv;

  // åβ
  for (;;){
    mpid = rcv_msg(TCPIP_MM_TYPE, &dummy, sizeof(MESSAGE), WAIT|NOCLR);
    if (mpid < ER_OK && mpid != ER_PAR) {
      // åμ˼
      throw ReturnState::TCP_PROCMSG_RCV_FAILED;
    }
    if (dummy.msg_type != TCPIP_MS_TYPE){
      // طʤå
      clr_msg(MM_ALL, MM_ALL);
      continue;
    }
    msize = dummy.msg_size + sizeof(W) * 2;
    msg = reinterpret_cast<MScriptMsg*>(new UB[msize]);
    
    // åܼ
    rv = rcv_msg(TCPIP_MM_TYPE, (MESSAGE*)msg, msize, NOWAIT|CLR);
    if (rv < ER_OK && rv != mpid){
      if (msg != 0){
        delete [] reinterpret_cast<UB*>(msg);
        msg = 0;
      }
      throw ReturnState::TCP_PROCMSG_RCV_FAILED;
    }

    debug_printf("<< Received Message >>\n");
    debug_printf("sender   : %d\n", mpid);
    debug_printf("msg_type : %d\n", msg->msg_type);
    debug_printf("msg_size : %d\n", msg->msg_size);
    debug_printf("ext_size : %d\n", msg->ext_size);
    debug_printf("msg_body :");
#ifdef DEBUG
    for (int d = 0; d < (msg->msg_size - sizeof(W)); d++){
      printf(" %02x", msg->msg_body[d]);
    }
#endif    
    debug_printf("\n\n");
    break;
  }
  return msg;
}

// å
void sendMessage(const MScriptMsg *msg)
{
  snd_msg(-1, (MESSAGE*)msg, WAIT);
  
  debug_printf("<< Sent Message >>\n");
  debug_printf("msg_type : %d\n", msg->msg_type);
  debug_printf("msg_size : %d\n", msg->msg_size);
  debug_printf("ext_size : %d\n", msg->ext_size);
  debug_printf("msg_body :");
#ifdef DEBUG
  for (int d = 0; d < (msg->msg_size - sizeof(W)); d++){
    printf(" %02x", msg->msg_body[d]);
  }
#endif
  debug_printf("\n\n");
}

// Х
void sendIntegerMessage(int val)
{
  MScriptMsg *msg = 
    reinterpret_cast<MScriptMsg*>(new UB[4 + sizeof(MScriptMsg)]);

  *(reinterpret_cast<int*>(msg->msg_body)) = val;
  msg->msg_type = TCPIP_MS_TYPE;
  msg->msg_size = sizeof(W) + sizeof(W);
  msg->ext_size = 0;
  sendMessage(msg);

  if (msg != 0){
    delete [] reinterpret_cast<UB*>(msg);
  }
}

// Хμ
int receiveIntegerMessage()
{
  MScriptMsg *msg = receiveMessage();

  if (msg == 0){
    throw ReturnState::TCP_PROCMSG_RCV_FAILED;
  }  
  int val = *((int*)msg->msg_body);
  delete [] reinterpret_cast<UB*>(msg);
  
  return val;
}

// åȤɤߤȤä̤ƥץ
void sendSocketInput(YTCPSocket &sock, int size)
{
  MScriptMsg *msg = 
    reinterpret_cast<MScriptMsg*>(new UB[size + sizeof(MScriptMsg)]);

  try {
    sock.read((B*)(msg->msg_body), size);
  }
  catch (YException *e){
    int val = ReturnState::TCP_UNDEFINED;
    switch (e->getErrorID()){
    case EX_TIMEDOUT:
      val = ReturnState::TCP_OPERATION_TIMEDOUT;
      break;
    case EX_CONNABORTED:
    case 0:
      val = ReturnState::TCP_CONNECTION_ABORTED;
      break;
    }
    delete e;
    throw val;
  }
  sendIntegerMessage(ReturnState::TCP_OK);
  msg->msg_type = TCPIP_MS_TYPE;
  msg->msg_size = size + sizeof(W);
  msg->ext_size = 0;
  sendMessage(msg);

  if (msg != 0){
    delete [] reinterpret_cast<UB*>(msg);
  }
}

// ץä̤򥽥åȤ˽񤭹
void receiveSocketOutput(YTCPSocket &sock)
{
  MScriptMsg *msg = 0;
  if ((msg = receiveMessage()) == 0){
    throw ReturnState::TCP_PROCMSG_RCV_FAILED;
  }
  try {
    sock.write((B*)(msg->msg_body), msg->msg_size - sizeof(W));
  }
  catch (YException *e){
    int val = ReturnState::TCP_UNDEFINED;
    switch (e->getErrorID()){
    case EX_TIMEDOUT:
      val = ReturnState::TCP_OPERATION_TIMEDOUT;
      break;
    case EX_CONNABORTED:
      val = ReturnState::TCP_CONNECTION_ABORTED;
      break;
    }
    delete e;
    throw val;
  }
  sendIntegerMessage(ReturnState::TCP_OK);
  if (msg != 0){
    delete [] reinterpret_cast<UB*>(msg);
  }
}

// ХåեˤޤäХȿ
void sendSocketBufferSize(YTCPSocket &sock)
{
  W val;
  if (so_ioctl(sock.getSocketID(), FIONREAD, (W)&val) < 0){
    throw ReturnState::TCP_IOCTL_FAILED;
  }  
  sendIntegerMessage(ReturnState::TCP_OK);
  sendIntegerMessage(val);
}


// TC[] -> unsigned int
unsigned int tcs2uint(const TC* org)
{
  int num = 0;
  
  for (int i = 0; org[i] != TNULL; i++){
    if (org[i] >= TK_0 && org[i] <= TK_9){
      num *= 10;
      num += (org[i] - TK_0);
    }
    else {
      return 0;
    }
  }
  
  return num;
}

// ȡڤʬ(ڤؤбƤʤΤ)
//  ɤΥץǤϻѤʤäġ
#if 0
int split_by_comma(std::vector<YString>* result, const TC* org)
{
  result->clear(); // ˤΤա

  int front = 0;
  std::vector<TC> buf;

  for (int i = 0; org[i] != TNULL; i++){
    if (org[i] == CMMA){
      buf.push_back(TNULL);
      YString str(&(*(buf.begin())));
      result->push_back(str);
      buf.clear();
    }
    else {
      buf.push_back(org[i]);
    }
  }
  if (!buf.empty()){
    buf.push_back(TNULL);
    YString str(buf.begin());
    result->push_back(str);
  }

  return result->size();
}
#endif

#endif // DEFINE_H_COMMON
