// -------------------------------------------------------------
//  ޥץ TCP/IPץ
//   --  --
//    (C)Copyright 2004, Yashiro Takeshi
//     This program is distributed under the MIT License.
// -------------------------------------------------------------

//#define DEBUG  // ǥХå⡼

#include <stdarg.h>
#include <basic.h>
#include <bstdio.h>
#include <bstring.h>
#include <tstring.h>
#include <vector>
#include <map>
#include "ystring.h"
#include "yexception.h"
#include "ytcpsocket.h"
#include "errorpanel.h"

using namespace YLibDraft;

#include "common.h"

int ppid = -1;

std::map<int, YTCPSocket*> sfmap;

// ƥץ¸ߤĥ뤿ΥХå饦ɥ
void ppid_monitor_task(W arg)
{
  YTCPSocket *sock = (YTCPSocket*)arg;

  for (;;){
    if (prc_sts(ppid, NULL, NULL) == ER_NOPRC){
      break;
    }
    slp_tsk(500);
  }

  for (std::map<int, YTCPSocket*>::iterator i = sfmap.begin();
       i != sfmap.end(); ++i){
    delete i->second;
  }

  sock->close();
  ext_prc(0);
}

// ᥤ
extern "C" W MAIN(MESSAGE *msg)
{
  P_STATE psts;
  int port = 0;
  int retval = ReturnState::TCP_OK;
  
  try {
    // å(ץ)ʬ
    TC* argv0 = (TC*)&(msg->msg_body);
    TC* argv1 = argv0;
    while (*argv1 == L'') argv1++;
    while (*argv1 != TNULL && *argv1 != L'') argv1++;
    while (*argv1 == L'') argv1++;
    if (*argv1 == TNULL){
      throw ReturnState::TCP_ARGNUM_STRANGE;
    }

    // ݡֹ
    port = tcs2uint(argv1);
    debug_printf("port: %d\n", port);
    
    YTCPSocket sock;

    // Хå饦ɥ֤εư
    P_STATE psts;
    prc_sts(0, &psts, NULL);
    ppid = psts.parpid;

    cre_tsk(ppid_monitor_task, psts.priority, (W)&sock);

    // bind, listen
    try {
      sock.bind(port);
      sock.listen(10); // -- ³Ϥǻ
    }
    catch (YException *e){
      delete e;
      throw ReturnState::TCP_BINDLISTEN_FAILED;
    }
    sendIntegerMessage(ReturnState::TCP_OK);

    // å̿Υ롼
    MScriptMsg *msg = 0;

    for (bool cont = true; cont; ){
      if ((msg = receiveMessage()) == 0){
        debug_printf("msg_loop : TCP_PROGMSG_RCV_FAILED\n");
        throw ReturnState::TCP_PROCMSG_RCV_FAILED;
      }

      if (msg->msg_size <= 6 || ((TC*)(msg->msg_body))[0] == TNULL){
        if (msg != 0){
          delete [] reinterpret_cast<UB*>(msg);
          msg = 0;
        }
        throw ReturnState::TCP_COMMAND_UNDEFINED;
      }

      // :
      //   ΤȤϰʲν󲽤ʤȤȤ롣
      //   ͳϡ
      //     ʤ
      //     MSENDΥХåեϹ⡹4096[bytes]Τäʤ
      //   Ĥͳˤޤ
      //   (;͵ΤȤϼ褦Ȼפޤ)

      try {
        switch (((TC*)(msg->msg_body))[0]){
        case L'':
        case L'':
          // "accept" / <err> / <int:sockfd>
          {
            YTCPSocket *new_sock = sock.accept();
            if (new_sock != 0){
              sfmap.insert(std::make_pair(new_sock->getSocketID(), new_sock));
              sendIntegerMessage(ReturnState::TCP_OK);
              sendIntegerMessage(new_sock->getSocketID());
            }
            else {
              throw ReturnState::TCP_ACCEPT_FAILED;
            }
          }
          break;
        case L'':
        case L'':
          // "read, <size>, <sockfd>" / <err>, <char[]:buf>
          {
            int size = receiveIntegerMessage();
            int fd = receiveIntegerMessage();
            std::map<int, YTCPSocket*>::iterator p = sfmap.find(fd);

            if (p == sfmap.end()){
              throw ReturnState::TCP_SOCKETFD_WRONG;
            }

            sendSocketInput(*(p->second), size);
          }
          break;
        case L'':
        case L'':
          // "write, <sockfd>" / <err> / <char[]:buf>
          {
            int fd = receiveIntegerMessage();
            std::map<int, YTCPSocket*>::iterator p = sfmap.find(fd);
            if (p == sfmap.end()){
              throw ReturnState::TCP_SOCKETFD_WRONG;
            }

            receiveSocketOutput(*(p->second));
          }
          break;
        case L'':
        case L'':
          // "close, <sockfd>" / <err>
          {
            int fd = receiveIntegerMessage();
            std::map<int, YTCPSocket*>::iterator p = sfmap.find(fd);
            if (p == sfmap.end()){
              throw ReturnState::TCP_SOCKETFD_WRONG;
            }

            p->second->close();
            sfmap.erase(p);
          }
          break;
        case L'':
        case L'':
          // "nbytes, <sockfd>" / <err> / <int:size>
          {
            int fd = receiveIntegerMessage();
            std::map<int, YTCPSocket*>::iterator p = sfmap.find(fd);

            if (p == sfmap.end()){
              throw ReturnState::TCP_SOCKETFD_WRONG;
            }

            sendSocketBufferSize(*(p->second));
          }
          break;
        case L'':
        case L'':
          // "shutdown" / <err>
          cont = false;
          break;
        default:
          if (msg != 0){
            delete [] reinterpret_cast<UB*>(msg);
          }
          throw ReturnState::TCP_COMMAND_UNDEFINED;
        }
      
        if (msg != 0){
          delete [] reinterpret_cast<UB*>(msg);
        }
      }
      catch (int val){
        if (val == ReturnState::TCP_CONNECTION_ABORTED){
          throw;
        }
        // Τۤξ̵뤷ƥ롼פ³
        sendIntegerMessage(val);
      }
    }

    // Ф
    for (std::map<int, YTCPSocket*>::iterator i = sfmap.begin();
         i != sfmap.end(); ++i){
      delete i->second;
    }

    sock.close();
  }
  catch (int v){
    debug_printf("error: (%d)", v);
    retval = v;
  }
  catch (YException *e){
    const TC* s = e->getMessage();
    debug_printf("error: %S (%d)\n", s, ReturnState::TCP_UNDEFINED);
    delete e;
    retval = ReturnState::TCP_UNDEFINED;
  }

exit_prog:
  // ǡretval
  sendIntegerMessage(retval);
  return retval;
}

